;////////////////////////////////////////////////////////////////////////////;
;/                                                                          /;
;////////////////////////////////////////////////////////////////////////////;
	.include "common\global.s"

;////////////////////////////////////////////////////////////////////////////;
;/ absolute ram                                                             /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_BSS_ABS (ABS)

	.org	0xD000
_tilemap2::
	.ds		32*32

	.org	0xD400		;SEE "go to attrmap2"
_attrmap2::
	.ds		32*32
	
	.org	0xDD00
_oam1::
	.ds		160

	.org	0xDE00
_oam2::
	.ds		160

;////////////////////////////////////////////////////////////////////////////;
;/ _Scanmap                                                                 /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE

_Scanmap::
	push	bc
	lda		hl, 4(sp)
	ld		a, (hl)
	ld		b, a


	ld		de, #_tilemap2
	ld		l, #32

.row_loop:

	ld		c, #20
.col_loop:
	res		2, d		;go to tilemap2
	ld		a, (de)			;read tile
	set		2, d		;go to attrmap2
	;and		a, #0xFE	;8x16 font
	;jr		.palblink	;!!!!
	and		a, #0xE
	cp		a, b			;good tile?
	jr		z, .palblink	;yup


.paldec:
	ld		a, (de)
	and		a, #0x03
	jr		z, 1$		;already 0
	ld		a, (de)
	dec		a
	ld		(de), a
1$:
	;jr		.next


.next:
	inc		de
	dec		c			;visible loop
	jr		nz, .col_loop

	ld		a, #11		;skip non-visable area
	add		a, e
	ld		e, a
	inc		de
	
	;jr		nz, .row_loop
	;inc		d				;
	;bit		3, d

	dec		l
	jr		nz,	.row_loop
	
	
	pop		bc
	ret


.palblink:
	;set pal lower bits to 3
	
	;;ld		a, (de)
	;;and		a, #3
	;;jr		nz, .next	;already fading

	ld		a, b		;nnnnnnnx
	sla		a			;nnnnnnx0
	and		a, #0x04	;00000n00
	or		a, #0x83	;10000?11
	;ld	a, #0x83	;!!!!
	ld		(de), a		;write attr
	jr		.next
