//////////////////////////////////////////////////////////////////////////////
// asm.h                                                                    //
//////////////////////////////////////////////////////////////////////////////
#ifndef _ASM_H
#define _ASM_H

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include "common.h"

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
//extern void (*vbl_irq)();
extern u8 scx[80];	// cos/sin * x interleaved
extern s8 stab[];
extern s8 ctab[];
extern s16 s,c;
extern s16 s_ox, c_ox, s_oy, c_oy;
extern u8 *mp;

//////////////////////////////////////////////////////////////////////////////
// prototypes                                                               //
//////////////////////////////////////////////////////////////////////////////
void InitStack();
void RotoTiles();
void SetRot();
extern u8 Do2[];			// relocated to _Do2_dest !!!
extern u8 Do2_dest[];
extern u8 Do2_end[];
void Do2_dest2();			// same but as function


#endif	// _ASM_H
